// "ieee-math.cc"
/*
  This puts the X86 FPU in 64-bit precision mode.  The default
  under Linux is to use 80-bit mode, which produces subtle
  differences from FreeBSD and other systems, eg,
  (int)(1000*atof("0.3")) is 300 in 64-bit mode, 299 in 80-bit
  mode.
*/

#include <fpu_control.h>
namespace {
  class MATH {
    fpu_control_t old_cw;
  public:
    MATH() {
      fpu_control_t cw;
      _FPU_GETCW(cw);
      old_cw = cw;
      cw &= ~_FPU_EXTENDED;
      cw |= _FPU_DOUBLE;
      _FPU_SETCW(cw);
    }
    ~MATH() {
      _FPU_SETCW(old_cw);
    }    
  };
  
  MATH x;
}
